<template>
  <Button
    icon="pi pi-id-card"
    iconPos="left"
    label="Créer un compte ortho"
    class="p-button-primary"
    @click="visible = true"
  />
  <Dialog v-model:visible="visible">
    <template #header>
      <h3>Création d'un nouveau compte ortho</h3>
    </template>

    <div>
      <h5 :class="validateClass">Tous les champs doivent être remplis</h5>
      <div class="flex flex-direction-row">
        <div>
          <h5 for="name">Nom</h5>
          <InputText id="name" type="text" placeholder="Nom" v-model="nom" :class="nameClass" />
        </div>
        <div>
          <h5 for="surname">Prénom</h5>
          <InputText
            id="surname"
            placeholder="Prénom"
            type="text"
            v-model="prenom"
            :class="surnameClass"
          />
        </div>
      </div>
      <h5 for="email">Adresse mail</h5>
      <InputText
        id="email"
        type="email"
        placeholder="Adresse mail"
        v-model="email"
        :class="niveauClass"
      />

      <h5 for="password">Mot de passe</h5>
      <InputText
        id="password"
        type="password"
        placeholder="Mot de passe"
        v-model="password"
        :class="passwordClass"
      />

      <p>Pour plus de sécurité, lors de la première connexion de l'utilisateur. Le mot de passe devra être changé</p>

      <p class="errorForm" v-if="formError">{{ formError }}</p>
    </div>

    <template #footer>
      <Button
        :loading="formLoading"
        label="Créer"
        class="p-button-primary"
        @click="handleCreateOrthoAccount()"
      />
    </template>
  </Dialog>
</template>

<script>
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import Image from "primevue/image";
import InputText from "primevue/inputtext";
import Calendar from "primevue/calendar";

import axios from 'axios';

export default {
  name: "Create Ortho Account Page",
  components: {
    Button,
    Dialog,
    Image,
    InputText,
    Calendar,
  },
  data() {
    return {
      visible: false,
        nom: '',
        prenom: '',
        email: '',
        password: '',
      validateClass: "validate-form",
      nameClass: "validate-name",
      surnameClass: "validate-surname",
      niveauClass: "validate-niveau",
      passwordClass: "validate-niveau",
      formError: null,
      formLoading: false
    };
  },
  methods: {
    uid() {
      return (performance.now().toString(36)+Math.random().toString(36)).replace(/\./g,"");
    },
    async handleCreateOrthoAccount() {
      this.formLoading = true
      this.formError = null
      if (
        this.nom === "" ||
        this.prenom === "" ||
        this.email === "" ||
        this.password === ""
      ) {
        this.formLoading = false
        this.validateClass = "non-validate-form";
        this.nom === ""
          ? (this.nameClass = "non-validate-name")
          : (this.nameClass = "validate-name");
        this.prenom === ""
          ? (this.surnameClass = "non-validate-surname")
          : (this.surnameClass = "validate-surname");
        this.email === ""
          ? (this.niveauClass = "non-validate-niveau")
          : (this.niveauClass = "validate-niveau");
        this.password === ""
          ? (this.passwordClass = "non-validate-niveau")
          : (this.passwordClass = "validate-niveau")
      } else {
          await axios.put('/orthophonistes/create', {
            nom: this.nom,
            prenom: this.prenom,
            email: this.email,
            grade: 0,
            password: this.password
        }).then(res => {
            this.$store.commit("addNewOrtho", {ortho: res.data})
            this.nom = "";
            this.prenom = "";
            this.email = "";
            this.password = "";
            this.validateClass = "validate-form";
            this.nameClass = "validate-name";
            this.surnameClass = "validate-surname";
            this.niveauClass = "validate-niveau";
            this.passwordClass = "validate-niveau"
            this.visible = false;
            this.formLoading = false
        }).catch (err => {
          if ('detail' in err.response.data && err.response.data.detail == "Email already used") {
            this.formLoading = false
            this.formError = "Cette adresse mail est déjà utilisée"
          } else {
            this.formLoading = false
            alert(JSON.stringify(err))
            console.log(err)
          }
        })
      }
    },
  },
};
</script>

<style lang="scss">
.validate-form {
  display: none;
}

.errorForm {
  color: red;
  font-size: 14px;
}

.non-validate-form {
  color: red;
  padding-bottom: 0.5rem;
}

.non-validate-name {
  border-color: red !important;
}

.non-validate-surname {
  border-color: red !important;
}

.non-validate-naissance > input {
  border-color: red;
}

.non-validate-niveau {
  border-color: red !important;
}
</style>